/*
	AQTRONIX XML Configuration Editor
	Copyright 2002 Parcifal Aertssen

	This file is part of AQTRONIX XML Configuration Editor.

    AQTRONIX XML Configuration Editor is free software; you can redistribute
	it and/or modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

    AQTRONIX XML Configuration Editor is distributed in the hope that it will
	be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX XML Configuration Editor; if not, write to the 
	Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
// ConfigDoc.h : interface of the CConfigDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CONFIGDOC_H__76ACAB09_7BCF_47B3_8772_98F52C284E3C__INCLUDED_)
#define AFX_CONFIGDOC_H__76ACAB09_7BCF_47B3_8772_98F52C284E3C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "XMLObject.h"
#include "XMLDocument.h"

class CConfigDoc : public CDocument
{
protected: // create from serialization only
	CConfigDoc();
	DECLARE_DYNCREATE(CConfigDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CConfigDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	virtual void DeleteContents();
	virtual BOOL CanCloseFrame(CFrameWnd* pFrame);
	//}}AFX_VIRTUAL

// Implementation
public:
	CXMLDocument* pCurrentDocument;
	CString KeyParameter(CString key, CString par);
	UINT id;
	CPtrList ptrlist;
	CString xml;
	virtual ~CConfigDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CConfigDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void AddDocument(CString& name);
	void AddTitle(CString& label);
	void AddUnknown(CString& name);
	void AddSeparator(CString& label);
	void AddMap(CString& label, CString& values,CString& explanation);
	void AddList(CString& label, CString& values, CString& explanation);
	void AddEditBox(CString& label, CString& value, CString& defaultvalue, CString& explanation);
	void AddCheckBox(CString& label, bool checked, bool defaultvalue, CString& explanation);
	void ObjectParser();
	void XMLParser();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONFIGDOC_H__76ACAB09_7BCF_47B3_8772_98F52C284E3C__INCLUDED_)
