/*
	AQTRONIX XML Configuration Editor
	Copyright 2002 Parcifal Aertssen

	This file is part of AQTRONIX XML Configuration Editor.

    AQTRONIX XML Configuration Editor is free software; you can redistribute
	it and/or modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

    AQTRONIX XML Configuration Editor is distributed in the hope that it will
	be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX XML Configuration Editor; if not, write to the 
	Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
// ConfigView.cpp : implementation of the CConfigView class
//

#include "stdafx.h"
#include "Config.h"

#include "ConfigDoc.h"
#include "ConfigView.h"

#include "XMLObject.h"
#include "XMLCheckBox.h"
#include "XMLEditBox.h"
#include "XMLList.h"
#include "XMLMap.h"
#include "XMLSeparator.h"
#include "XMLTitle.h"
#include "XMLDocument.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfigView

IMPLEMENT_DYNCREATE(CConfigView, CScrollView)

BEGIN_MESSAGE_MAP(CConfigView, CScrollView)
	//{{AFX_MSG_MAP(CConfigView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigView construction/destruction

CConfigView::CConfigView()
{
}

CConfigView::~CConfigView()
{
}

BOOL CConfigView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CConfigView drawing

void CConfigView::OnDraw(CDC* pDC)
{
	//CConfigDoc* pDoc = GetDocument();
}

/////////////////////////////////////////////////////////////////////////////
// CConfigView diagnostics

#ifdef _DEBUG
void CConfigView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CConfigView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CConfigDoc* CConfigView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CConfigDoc)));
	return (CConfigDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CConfigView message handlers

void CConfigView::OnInitialUpdate() 
{
	CScrollView::OnInitialUpdate();

	CConfigDoc* pDoc = GetDocument();

	ScrollToPosition(CPoint(0,0));

	//draw document
	CPoint viewpos(0,20);	//extra space top

	POSITION pos;
	CXMLObject* control;
	pos = pDoc->ptrlist.GetHeadPosition();
	while(pos!=NULL){
		control = (CXMLObject*)pDoc->ptrlist.GetNext(pos);
		viewpos += control->Create(this,viewpos);
	}

	viewpos.y += 20;	//extra space bottom

	//scroll bars
	CSize docSize(810,viewpos.y);
	CRect rect;
	GetClientRect(&rect);
	CSize pageSize(rect.right,rect.bottom);
	CSize lineSize(0,16);
	SetScrollSizes(MM_TEXT,docSize,pageSize,lineSize);
}

BOOL CConfigView::OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult) 
{
	return CScrollView::OnChildNotify(message, wParam, lParam, pLResult);
}

BOOL CConfigView::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	return CScrollView::OnNotify(wParam, lParam, pResult);
}

void CConfigView::ScrollDownTo(long pos)
{
	//scroll down to a certain position
	CScrollView::ScrollToPosition(CPoint(0,pos));
}
