/*
	AQTRONIX XML Configuration Editor
	Copyright 2002 Parcifal Aertssen

	This file is part of AQTRONIX XML Configuration Editor.

    AQTRONIX XML Configuration Editor is free software; you can redistribute
	it and/or modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

    AQTRONIX XML Configuration Editor is distributed in the hope that it will
	be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX XML Configuration Editor; if not, write to the 
	Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
// MyStatic.cpp : implementation file
//

#include "stdafx.h"
#include "Config.h"
#include "MyStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyStatic

CBrush CMyStatic::m_bk_brush(RGB(255,255,255));

CMyStatic::CMyStatic()
{
}

CMyStatic::~CMyStatic()
{
}


BEGIN_MESSAGE_MAP(CMyStatic, CStatic)
	//{{AFX_MSG_MAP(CMyStatic)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyStatic message handlers

BOOL CMyStatic::OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult) 
{
	//if "message" is not the message you're after, do default processing:

   // For 16-bit applications change WM_CTLCOLOREDIT to WM_CTLCOLOR
      if (message != WM_CTLCOLORSTATIC)
      {
         return CStatic::OnChildNotify(message,wParam,lParam,pLResult);
      }

   // Set the text foreground to red:
      HDC hdcChild = (HDC)wParam;
      SetTextColor(hdcChild, RGB(0,0,0));

   // Set the text background to green:
      SetBkColor(hdcChild, RGB(255,255,255));

   // Send what would have been the return value of OnCtlColor() - the
   // brush handle - back in pLResult:
      *pLResult = (LRESULT)(m_bk_brush.GetSafeHandle());

   // Return TRUE to indicate that the message was handled:
      return TRUE;
}
