/*
	AQTRONIX XML Configuration Editor
	Copyright 2002 Parcifal Aertssen

	This file is part of AQTRONIX XML Configuration Editor.

    AQTRONIX XML Configuration Editor is free software; you can redistribute
	it and/or modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

    AQTRONIX XML Configuration Editor is distributed in the hope that it will
	be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX XML Configuration Editor; if not, write to the 
	Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
// XMLCheckBox.cpp: implementation of the CXMLCheckBox class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Config.h"
#include "XMLObject.h"
#include "XMLCheckBox.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXMLCheckBox::CXMLCheckBox()
{
}

CXMLCheckBox::~CXMLCheckBox()
{
}

void CXMLCheckBox::SetValues(CString& name_, WORD id_, bool value_, bool defaultvalue_, CString& explanation_)
{
	name = XMLDecode(name_);
	value = value_;
	defaultvalue = defaultvalue_;
	explanation = XMLDecode(explanation_);
	id = id_;
}

CString CXMLCheckBox::XML()
{
	//get value of control
	value = checkbox.GetCheck()==0?false:true;
	
	CString tmp('<');
	TCHAR str[34];

	tmp += XMLEncode(name);
	tmp += " App='Option' Default='";
	tmp += XMLEncode(itoa(defaultvalue,str,10));
	tmp += "' Explanation='";
	tmp += XMLEncode(explanation);
	tmp += "'>";
	tmp += XMLEncode(itoa(value,str,10));
	tmp += "</";
	tmp += XMLEncode(name);
	tmp += ">";
	
	return tmp;
}

CPoint CXMLCheckBox::Create(CWnd *pParentWindow, CPoint pos)
{
	//set font
	LOGFONT logfont;
	logfont.lfHeight = 14;
	//logfont.lfWidth = 8;
	logfont.lfEscapement = 0;
	logfont.lfOrientation = 0;
	logfont.lfWeight = FW_NORMAL;
	logfont.lfItalic = FALSE;
	logfont.lfUnderline = FALSE;
	logfont.lfStrikeOut = FALSE;
	logfont.lfCharSet = ANSI_CHARSET;
	logfont.lfOutPrecision = OUT_DEFAULT_PRECIS;
	logfont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	logfont.lfQuality = DEFAULT_QUALITY;
	logfont.lfPitchAndFamily = DEFAULT_PITCH;
	strcpy(logfont.lfFaceName,"Verdana");

	//value
	checkbox.Create(NameDecode(name),WS_CHILD|WS_VISIBLE|WS_TABSTOP|BS_AUTOCHECKBOX,CRect(CPoint(pos.x+200,pos.y),CPoint(pos.x+495,pos.y+20)),pParentWindow,id);
	font_value.CreateFontIndirect(&logfont);
	checkbox.SetFont(&font_value);
	checkbox.SetCheck(value);

	//default
	checkboxdefault.Create("Default:",WS_CHILD|WS_VISIBLE|WS_TABSTOP|BS_CHECKBOX|BS_LEFTTEXT,CRect(CPoint(pos.x+500,pos.y),CPoint(pos.x+570,pos.y+20)),pParentWindow,0xffff);
	font_default.CreateFontIndirect(&logfont);
	checkboxdefault.SetFont(&font_default);
	checkboxdefault.SetCheck(defaultvalue);

	//explanation
	lblexp.Create(explanation,WS_CHILD|WS_VISIBLE|SS_NOPREFIX,CRect(CPoint(pos.x+220,pos.y+20),CPoint(pos.x+810,pos.y+60)),pParentWindow);
	logfont.lfHeight = 12;
	font_explanation.CreateFontIndirect(&logfont);
	lblexp.SetFont(&font_explanation);

	return CPoint(0,60);
}

bool CXMLCheckBox::IsChanged()
{
	if ((checkbox.GetCheck()==0?false:true)==value){
		return false;
	}else{
		return true;
	}
}
