/*
	AQTRONIX XML Configuration Editor
	Copyright 2003 Parcifal Aertssen

	This file is part of AQTRONIX XML Configuration Editor.

    AQTRONIX XML Configuration Editor is free software; you can redistribute
	it and/or modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

    AQTRONIX XML Configuration Editor is distributed in the hope that it will
	be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX XML Configuration Editor; if not, write to the 
	Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/// XMLDocument.h: interface for the CXMLDocument class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XMLDOCUMENT_H__402AFA27_C1C9_43B1_A5A6_2780AA9E920C__INCLUDED_)
#define AFX_XMLDOCUMENT_H__402AFA27_C1C9_43B1_A5A6_2780AA9E920C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyStatic.h"
#include "XMLObject.h"
#include "Globals.h"

class CXMLDocument : public CXMLObject  
{
friend class CXMLSeparator;
public:
	long LookupPos(UINT nID);
	void AddItem(CString name, CPoint pos);
	virtual CPoint Create(CWnd *pParentWindow, CPoint pos);
	virtual CString XML();
	CXMLDocument();
	virtual ~CXMLDocument();
private:
	long ID_Count;	//TO DO: static
	CMenu DocumentMenu;
	CMenu* pAppMenu;
	CWnd* pViewWindow;
	CWnd* pAppWindow;
	CMapPtrToPtr PosMap;
protected:
	void DrawMenus();
};

#endif // !defined(AFX_XMLDOCUMENT_H__402AFA27_C1C9_43B1_A5A6_2780AA9E920C__INCLUDED_)
