/*
	AQTRONIX XML Configuration Editor
	Copyright 2002 Parcifal Aertssen

	This file is part of AQTRONIX XML Configuration Editor.

    AQTRONIX XML Configuration Editor is free software; you can redistribute
	it and/or modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

    AQTRONIX XML Configuration Editor is distributed in the hope that it will
	be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX XML Configuration Editor; if not, write to the 
	Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
// XMLEditBox.cpp: implementation of the CXMLEditBox class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Config.h"
#include "XMLObject.h"
#include "XMLEditBox.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXMLEditBox::CXMLEditBox()
{
}

CXMLEditBox::~CXMLEditBox()
{
}

CString CXMLEditBox::XML()
{
	//get value of control
	value = GetText();

	CString tmp('<');

	tmp += XMLEncode(name);
	tmp += " App='Text' Default='";
	tmp += XMLEncode(defaultvalue);
	tmp += "' Explanation='";
	tmp += XMLEncode(explanation);
	tmp += "'>";
	tmp += XMLEncode(value);
	tmp += "</";
	tmp += XMLEncode(name);
	tmp += ">";
	
	return tmp;
}

void CXMLEditBox::SetValues(CString& name_, WORD id_, CString& value_, CString& defaultvalue_, CString& explanation_)
{
	name = XMLDecode(name_);
	value = XMLDecode(value_);
	defaultvalue = XMLDecode(defaultvalue_);
	explanation = XMLDecode(explanation_);
	id = id_;
}

CPoint CXMLEditBox::Create(CWnd *pParentWindow, CPoint pos)
{
	//set font
	LOGFONT logfont;
	logfont.lfHeight = 14;
	//logfont.lfWidth = 8;
	logfont.lfEscapement = 0;
	logfont.lfOrientation = 0;
	logfont.lfWeight = FW_NORMAL;
	logfont.lfItalic = FALSE;
	logfont.lfUnderline = FALSE;
	logfont.lfStrikeOut = FALSE;
	logfont.lfCharSet = ANSI_CHARSET;
	logfont.lfOutPrecision = OUT_DEFAULT_PRECIS;
	logfont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	logfont.lfQuality = DEFAULT_QUALITY;
	logfont.lfPitchAndFamily = DEFAULT_PITCH;
	strcpy(logfont.lfFaceName,"Verdana");

	CString tmp;
	tmp = NameDecode(name);
	tmp += ':';

	//label
	label.Create(tmp,WS_CHILD|WS_VISIBLE|SS_NOPREFIX,CRect(CPoint(pos.x+200,pos.y),CPoint(pos.x+400,pos.y+20)),pParentWindow);
	font_label.CreateFontIndirect(&logfont);
	label.SetFont(&font_label);
	
	//value
	edit.Create(WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_AUTOHSCROLL,CRect(CPoint(pos.x+220,pos.y+20),CPoint(pos.x+505,pos.y+40)),pParentWindow,id);
	font_value.CreateFontIndirect(&logfont);
	edit.SetFont(&font_value);
	edit.SetWindowText((LPCTSTR)value);
	
	//default
	editdefault.Create(WS_CHILD|WS_VISIBLE|WS_BORDER|ES_AUTOHSCROLL|ES_READONLY,CRect(CPoint(pos.x+520,pos.y+20),CPoint(pos.x+810,pos.y+40)),pParentWindow,id);
	font_default.CreateFontIndirect(&logfont);
	editdefault.SetFont(&font_default);
	editdefault.SetWindowText((LPCTSTR)defaultvalue);
	
	//explanation
	lblexp.Create(explanation,WS_CHILD|WS_VISIBLE|SS_NOPREFIX,CRect(CPoint(pos.x+220,pos.y+40),CPoint(pos.x+810,pos.y+70)),pParentWindow);
	logfont.lfHeight = 12;
	font_explanation.CreateFontIndirect(&logfont);
	lblexp.SetFont(&font_explanation);
	
	return CPoint(0,70);
}

bool CXMLEditBox::IsChanged()
{
	if (GetText()==value){
		return false;
	}else{
		return true;
	}
}

CString CXMLEditBox::GetText()
{
	TCHAR buf[40960];
	int ret = edit.GetWindowText(buf,40960);
	buf[ret]='\0';
	return CString(buf);
	
}
