/*
	AQTRONIX XML Configuration Editor
	Copyright 2002 Parcifal Aertssen

	This file is part of AQTRONIX XML Configuration Editor.

    AQTRONIX XML Configuration Editor is free software; you can redistribute
	it and/or modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

    AQTRONIX XML Configuration Editor is distributed in the hope that it will
	be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX XML Configuration Editor; if not, write to the 
	Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
// XMLList.cpp: implementation of the CXMLList class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Config.h"
#include "XMLObject.h"
#include "XMLList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXMLList::CXMLList()
{
}

CXMLList::~CXMLList()
{
}

CString CXMLList::XML()
{
	//get values from controls
	GetValues(values);

	CString tmp('<');
	tmp += XMLEncode(name);
	tmp += " App='List' Explanation='";
	tmp += XMLEncode(explanation);
	tmp += "'>\r\n";

	POSITION pos;
	pos = values.GetHeadPosition();
	while(pos!=NULL){
		tmp += "<Item>";
		tmp += XMLEncode(values.GetNext(pos));
		tmp += "</Item>\r\n";
	}

	tmp += "</";
	tmp += XMLEncode(name);
	tmp += ">";
	return tmp;
}

CPoint CXMLList::Create(CWnd *pParentWindow, CPoint pos)
{
	//set font
	LOGFONT logfont;
	logfont.lfHeight = 14;
	//logfont.lfWidth = 8;
	logfont.lfEscapement = 0;
	logfont.lfOrientation = 0;
	logfont.lfWeight = FW_NORMAL;
	logfont.lfItalic = FALSE;
	logfont.lfUnderline = FALSE;
	logfont.lfStrikeOut = FALSE;
	logfont.lfCharSet = ANSI_CHARSET;
	logfont.lfOutPrecision = OUT_DEFAULT_PRECIS;
	logfont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	logfont.lfQuality = DEFAULT_QUALITY;
	logfont.lfPitchAndFamily = DEFAULT_PITCH;
	strcpy(logfont.lfFaceName,"Verdana");
	
	CString tmp;
	tmp = NameDecode(name);
	tmp += ':';

	//label
	label.Create(tmp,WS_CHILD|WS_VISIBLE|SS_NOPREFIX,CRect(CPoint(pos.x+200,pos.y),CPoint(pos.x+400,pos.y+20)),pParentWindow);
	font_label.CreateFontIndirect(&logfont);
	label.SetFont(&font_label);

	//value
	listctrl.Create(WS_CHILD|WS_VISIBLE|WS_TABSTOP|WS_BORDER|LVS_REPORT|LVS_EDITLABELS,CRect(CPoint(pos.x+220,pos.y+20),CPoint(pos.x+810,pos.y+180)),pParentWindow,id);
	font_values.CreateFontIndirect(&logfont);
	listctrl.SetFont(&font_values);
	listctrl.SetExtendedStyle(LVS_EX_GRIDLINES);
	listctrl.InsertColumn(0,"Values",LVCFMT_LEFT,570);
	POSITION posl; int i=0;
	posl = values.GetHeadPosition();
	while (posl!=NULL){
		i++;
		listctrl.InsertItem(i,values.GetNext(posl));
	}

	//explanation
	lblexp.Create(explanation,WS_CHILD|WS_VISIBLE|SS_NOPREFIX,CRect(CPoint(pos.x+220,pos.y+180),CPoint(pos.x+810,pos.y+220)),pParentWindow);
	logfont.lfHeight = 12;
	font_explanation.CreateFontIndirect(&logfont);
	lblexp.SetFont(&font_explanation);

	return CPoint(0,230);
}

bool CXMLList::IsChanged()
{
	CStringList list;
	GetValues(list);
	POSITION pos; POSITION posv;
	CString lval; CString vval;
	pos = list.GetHeadPosition();
	posv = values.GetHeadPosition();
	while(pos!=NULL && posv!=NULL){
		if(list.GetNext(pos)!=values.GetNext(posv)){
			return true;
			break;
		}
	}
	if(pos!=NULL)
		return true;
	if(posv!=NULL)
		return true;

	return false;
}

void CXMLList::SetValues(CString& name_, WORD id_, CStringList& values_, CString& explanation_)
{
	name = XMLDecode(name_);
	explanation = XMLDecode(explanation_);
	id = id_;
	POSITION pos; CString val;
	pos = values_.GetHeadPosition();
	values.RemoveAll();
	while(pos!=NULL){
		val = values_.GetNext(pos);
		values.AddTail(XMLDecode(val));
	}
}

bool CXMLList::GetValues(CStringList &list)
{
	list.RemoveAll();
	TCHAR buf[4097];
	int count = listctrl.GetItemCount();
	for(int i=0; i<count; i++){
		listctrl.GetItemText(i,0,buf,4096);
		buf[4096]='\0';	//make sure it is null terminated
		list.AddTail(buf);
	}
	return true;
}
