/*
	AQTRONIX XML Configuration Editor
	Copyright 2002 Parcifal Aertssen

	This file is part of AQTRONIX XML Configuration Editor.

    AQTRONIX XML Configuration Editor is free software; you can redistribute
	it and/or modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

    AQTRONIX XML Configuration Editor is distributed in the hope that it will
	be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX XML Configuration Editor; if not, write to the 
	Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
// XMLObject.cpp: implementation of the CXMLObject class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Config.h"
#include "XMLObject.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXMLObject::CXMLObject()
{
	//initialize with defaults
	name = "Unknown XML Object";
}

CXMLObject::~CXMLObject()
{
}

void CXMLObject::SetValues(CString& name_,WORD id_)
{
	//set values (xml decoded)
	name = XMLDecode(name_);
	id = id_;
}

CString CXMLObject::XML()
{
	//return object in xml form
	return "<" + XMLEncode(name) + ">";
}

CPoint CXMLObject::Create(CWnd *pParentWindow, CPoint pos)
{
	return CPoint(0,0);
}

CString CXMLObject::XMLEncode(const char *str)
{
	CString enc(str);
	enc.Replace("&","&amp;");
	enc.Replace("<","&lt;");
	enc.Replace(">","&gt;");
	enc.Replace("'","&apos;");
	enc.Replace("\"","&quot;");
	return enc;
}

CString CXMLObject::XMLDecode(const char *str)
{
	CString enc(str);
	enc.Replace("&lt;","<");
	enc.Replace("&gt;",">");
	enc.Replace("&apos;","'");
	enc.Replace("&quot;","\"");
	enc.Replace("&amp;","&");
	return enc;
}

CString CXMLObject::NameDecode(CString &str)
{
	CString tmp(str);
	tmp.Replace('_',' ');
	return tmp;
}

CString CXMLObject::NameEncode(CString &str)
{
	CString tmp(str);
	tmp.Replace(' ','_');
	return tmp;
}

bool CXMLObject::IsChanged()
{
	return false;
}
