/*
	AQTRONIX XML Configuration Editor
	Copyright 2002 Parcifal Aertssen

	This file is part of AQTRONIX XML Configuration Editor.

    AQTRONIX XML Configuration Editor is free software; you can redistribute
	it and/or modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

    AQTRONIX XML Configuration Editor is distributed in the hope that it will
	be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX XML Configuration Editor; if not, write to the 
	Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
// XMLSeparator.cpp: implementation of the CXMLSeparator class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Config.h"
#include "XMLSeparator.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXMLSeparator::CXMLSeparator()
{
	XMLDocument = NULL;
}

CXMLSeparator::~CXMLSeparator()
{
}

CString CXMLSeparator::XML()
{
	return "<" + XMLEncode(name) + " App='Separator'/>";
}

CPoint CXMLSeparator::Create(CWnd *pParentWindow, CPoint pos)
{
	//set font
	LOGFONT logfont;
	logfont.lfHeight = 18;
	//logfont.lfWidth = 8;
	logfont.lfEscapement = 0;
	logfont.lfOrientation = 0;
	logfont.lfWeight = FW_BOLD;
	logfont.lfItalic = TRUE;
	logfont.lfUnderline = FALSE;
	logfont.lfStrikeOut = FALSE;
	logfont.lfCharSet = ANSI_CHARSET;
	logfont.lfOutPrecision = OUT_DEFAULT_PRECIS;
	logfont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	logfont.lfQuality = DEFAULT_QUALITY;
	logfont.lfPitchAndFamily = DEFAULT_PITCH;
	strcpy(logfont.lfFaceName,"Verdana");

	//line
	line.Create(NULL,WS_CHILD|WS_VISIBLE|SS_ETCHEDHORZ|SS_SUNKEN,CRect(CPoint(pos.x,pos.y+10),CPoint(pos.x+810,pos.y+13)),pParentWindow);

	//label
	label.Create(NameDecode(name),WS_CHILD|WS_VISIBLE|SS_NOPREFIX,CRect(CPoint(pos.x,pos.y+13),CPoint(pos.x+810,pos.y+33)),pParentWindow);
	font.CreateFontIndirect(&logfont);
	label.SetFont(&font);

	//add to document
	if(XMLDocument!=NULL)
		XMLDocument->AddItem(name,pos);
	
	return CPoint(0,33);
}

void CXMLSeparator::SetValues(CString &name_, WORD id_, CXMLDocument *pCurrentDocument)
{
	//set values (xml decoded)
	name = XMLDecode(name_);
	id = id_;
	if(pCurrentDocument!=NULL)
		XMLDocument = pCurrentDocument;
}

void CXMLSeparator::SetValues(CString &name_, WORD id_)
{
	//set values (xml decoded)
	name = XMLDecode(name_);
	id = id_;
}
