#ifndef GLOBALS_H_INCLUDED
#define GLOBALS_H_INCLUDED
/*
 * Global defines
 *
 * To port this software to another platform (os / web server), add
 * global defines here and adjust the source, but do not break
 * existing functionality, just add custom defines!
 *
 */

//Which build, exclusive! (currently, only for IIS)
#define IISBUILD				//Builds for Windows + IIS (isapi filter)

//is this a private build (for personal use)
//#define PRIVATEBUILD			

//Headers
#define MAX_HEADER_SIZE	96000		//the maximum header size
#define MIN_HEADER_SIZE 4128		//average minimum header size: for best performance choose a min header size large enough for most header values.

//Errorhandling
#define ERROR_HANDLE				//use errorhandling in events (recommended)
#define DENY_ON_ERROR true			//protect the webserver at ALL costs, even when filter crashes! (recommended)

//Settings
#define XML_ENABLED					//enable XML for the settings (for GUI)

//Logging
#ifdef PRIVATEBUILD
#define SYSTEM_LOG_BUILD			//log in \system32\LogFiles dir
#endif
#define LOG_ONSENDRAW_ERROR false	//if true log on error in OnSendRawData
//#define LOG_DEBUG_ONREADRAWDATA	//log raw received data (not recommended: performance impact!)
//#define LOG_DEBUG_ONSENDRAWDATA	//log raw sent data (not recommended: performance impact!)

#endif //GLOBALS_H_INCLUDED