/*
    AQTRONIX C++ Security Library
    Copyright 2003 Parcifal Aertssen

    This file is part of AQTRONIX C++ Security Library.

    AQTRONIX C++ Security Library is free software; you can redistribute
    it and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    AQTRONIX C++ Security Library is distributed in the hope that it will
    be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX C++ Security Library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
    MA  02111-1307  USA
*/
// Settings.h: interface for the CSettings class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SETTINGS_H__270445F3_48E4_49D3_8EAF_CAB52E330BF9__INCLUDED_)
#define AFX_SETTINGS_H__270445F3_48E4_49D3_8EAF_CAB52E330BF9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define MAX_XML_FILE_SIZE 196000

#include "FileName.h"

class CSettings  
{
public:
	virtual bool WriteToFileINI(LPCTSTR fn);
	virtual bool WriteToFileXML(LPCTSTR fn);
	virtual bool WriteToFile(LPCTSTR fn);
	virtual bool WriteToRegistry();
	virtual bool WriteToActiveDirectory();
	virtual bool UpdateFromFile();
	virtual bool ReadFromActiveDirectory();
	virtual bool ReadFromRegistry();
	virtual void ParseXML(CString key, CString val);
	virtual bool ReadFromFile(LPCTSTR fn);
	virtual bool ReadFromFileINI(LPCTSTR fn);
	virtual bool ReadFromFileXML(LPCTSTR fn);
	virtual void LoadDefaults();
	virtual bool Update();
	CSettings();
	virtual ~CSettings();

protected:
	static void ConvertXMLToMap(CString& val, CMapStringToString& map);
	static void ConvertXMLToList(CString& val, CStringList& list);
	static CString XMLKeyParameter(CString key, CString par);
	static void AddTo(CStringList& list, LPCTSTR value);
	static void RemoveFrom(CStringList& list, LPCTSTR value);
	static CString XMLDecode(LPCTSTR str);
	static CString XMLEncode(LPCTSTR str);
	static CString ConvertMapToXML(LPCTSTR tag,CMapStringToString& map, LPCTSTR explanation = "");
	static CString ConvertListToXML(LPCTSTR tag, CStringList& List, LPCTSTR explanation = "");
	static CString ConvertStringToXML(LPCTSTR tag, LPCTSTR app, LPCTSTR value, LPCTSTR defaultvalue, LPCTSTR explanation = "");
	static void CleanupStringUCase(CString &str);
	static void CleanupListUCase(CStringList &list);
	static void CleanupListLCase(CStringList& list);
	static void CleanupList(CStringList& list);
	static CString ConvertMapToString(const CMapStringToString& map);
	static CString ConvertListToString(const CStringList& list);
	static void CleanupString(CString& str);
	static void CleanupStringLCase(CString& str);
	static void Split(LPCTSTR p, int length, CStringList& list);
	CTime Update_Time;
	CTime Update_fn_Timestamp;
	CString Update_fn;
};

#endif // !defined(AFX_SETTINGS_H__270445F3_48E4_49D3_8EAF_CAB52E330BF9__INCLUDED_)
