/*
    AQTRONIX C++ Security Library
    Copyright 2003 Parcifal Aertssen

    This file is part of AQTRONIX C++ Security Library.

    AQTRONIX C++ Security Library is free software; you can redistribute
    it and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    AQTRONIX C++ Security Library is distributed in the hope that it will
    be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX C++ Security Library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
    MA  02111-1307  USA
*/// URL.h: interface for the CURL class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_URL_H__7639661B_F026_4B18_A3C8_B86166A276B5__INCLUDED_)
#define AFX_URL_H__7639661B_F026_4B18_A3C8_B86166A276B5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CURL  
{
public:
	CString GetFragment();
	CString GetQuerystring();
	CString GetUrl();
	bool SetUrl(CString& URL);
	static bool IsValidScheme(CString& scheme);
	bool IsRFCCompliant();

	static CString URLEncodedToASCII(const char* str, bool convert_plus=true);
	static inline int HexToInt(const char* hex);
	
	CURL(CString strUrl = "");
	virtual ~CURL();

	CString RawUrl;
	CString Url;
	CString Querystring;
	CString Fragment;

protected:
	bool IsRFC1808Compliant();
	bool IsRFC1738Compliant();
};

#endif // !defined(AFX_URL_H__7639661B_F026_4B18_A3C8_B86166A276B5__INCLUDED_)
