/*
	AQTRONIX WebKnight - ISAPI Filter for securing IIS
	Copyright 2002 Parcifal Aertssen

	This file is part of AQTRONIX WebKnight.

    AQTRONIX WebKnight is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

    AQTRONIX WebKnight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX WebKnight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */

#if !defined(AFX_WEBKNIGHT_H__EDD4742C_4FAD_4D80_BC24_706E725204F9__INCLUDED_)
#define AFX_WEBKNIGHT_H__EDD4742C_4FAD_4D80_BC24_706E725204F9__INCLUDED_

// WEBKNIGHT.H - Header file for your Internet Server
//    WebKnight Filter

#include "resource.h"

#include "Globals.h"
#include "Logger.h"
#include "FileName.h"
#include "URL.h"
#include "WebKnightSettings.h"

class CWebKnightFilter : public CHttpFilter
{
	CLogger logger;
	CWebKnightSettings s;
	CCriticalSection crit;
public:
	CWebKnightFilter();
	~CWebKnightFilter();

// Overrides
	// ClassWizard generated virtual function overrides
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//{{AFX_VIRTUAL(CWebKnightFilter)
	public:
	virtual BOOL GetFilterVersion(PHTTP_FILTER_VERSION pVer);
	virtual DWORD OnReadRawData(CHttpFilterContext* pCtxt, PHTTP_FILTER_RAW_DATA pRawData);
	virtual DWORD OnPreprocHeaders(CHttpFilterContext* pfc, PHTTP_FILTER_PREPROC_HEADERS pHeaders);
	virtual DWORD OnUrlMap(CHttpFilterContext* pfc, PHTTP_FILTER_URL_MAP pUrlMap);
	virtual DWORD OnSendRawData(CHttpFilterContext* pfc, PHTTP_FILTER_RAW_DATA pRawData);
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CWebKnightFilter)
	//}}AFX_MSG
private:
	inline bool ScanQuerystring(CString& str);
	inline bool ScanUrl(const char* pUrl);
	inline void SetLoggerFields();
	inline void LogClientInfo(CHttpFilterContext* pfc);
	inline bool IsExcluded(CString& instance);
	inline bool DenyChar(const char* p,char c,const char* LogMsg);
	inline bool DenyString(const char* p, const char* pStr, const char* LogMsg);
	inline void HackResponse(CHttpFilterContext* pfc);
	CString GetHeader(CHttpFilterContext* pfc, PHTTP_FILTER_PREPROC_HEADERS pHeaders, char* h);
	CString GetServerVariable(CHttpFilterContext* pCtxt,char*);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WEBKNIGHT_H__EDD4742C_4FAD_4D80_BC24_706E725204F9__INCLUDED)
