/*
	AQTRONIX WebKnight - ISAPI Filter for securing IIS
	Copyright 2002 Parcifal Aertssen

	This file is part of AQTRONIX WebKnight.

    AQTRONIX WebKnight is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    AQTRONIX WebKnight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX WebKnight; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */

// WebKnightSettings.h: interface for the CWebKnightSettings class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WEBKNIGHTSETTINGS_H__E2FABE74_F5AD_44C6_A64E_FE3890A980EC__INCLUDED_)
#define AFX_WEBKnIGHTSETTINGS_H__E2FABE74_F5AD_44C6_A64E_FE3890A980EC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Settings.h"

class CWebKnightSettings : public CSettings  
{
public:
	bool Deny_URL_EncodingExploits;
	bool RFCCompliantURL;
	bool UseQuerystringRawScan;
	bool UseURLRawScan;
	virtual bool WriteToActiveDirectory();
	virtual bool WriteToRegistry();
	virtual bool ReadFromActiveDirectory();
	virtual bool ReadFromRegistry();

	bool LogGMT;
	bool Allow_WEBAPP_ASP;
	bool Allow_WEBAPP_ASPNET;
	bool Allow_WEBAPP_SBS;
	bool Allow_WEBAPP_Commerce;
	bool Allow_WEBAPP_BizTalk;
	bool Allow_WEBAPP_CertificateServices;
	bool Allow_WEBAPP_SPTS;
	bool Allow_WEBAPP_SPPS;
	bool Deny_COOKIE_EncodingExploits;
	bool Allow_WEBAPP_IISADMPWD;
	bool Allow_WEBAPP_WebDAV;
	bool Allow_WEBAPP_Flash;
	bool Allow_WEBAPP_Coldfusion;
	bool Allow_WEBAPP_Frontpage;
	bool Allow_WEBAPP_OWA;
	bool Log_HTTP_ERROR_ServerError;
	bool Log_HTTP_ERROR_ClientError;
	bool Deny_URL_HighBitShellcode;	//version 1.0 beta
	bool Deny_POST_HighBitShellcode;
	bool Deny_HEADER_HighBitShellcode;
	bool Deny_QUERYSTRING_HighBitShellcode;
	bool UseAllowHeaderContentType;
	CStringList Allow_HEADER_ContentType;
	bool Deny_FILENAME_DefaultDocument;
	bool Deny_POST_DirectoryTraversal;
	bool Deny_HEADER_DirectoryTraversal;
	bool Deny_QUERYSTRING_DirectoryTraversal;
	bool Deny_POST_EncodingExploits;
	bool Deny_HEADER_EncodingExploits;
	bool Deny_QUERYSTRING_EncodingExploits;
	bool RFCCompliantHostHeader;
	CString ResponseContents;
	bool ResponseDirectly;
	bool Deny_COOKIE_SQLinjection;
	bool Deny_HEADER_SQLinjection;
	bool UseDenyHeaderSequences;
	CStringList Deny_HEADER_Sequences;
	bool LogPerProcess;
	bool UseDenyFilenameCGIApplications;
	CStringList ExcludedInstances;
	bool UseExcludedInstances;
	bool Log_HTTP_X_FORWARDED_FOR;
	bool LogUserAgent;
	bool Log_HTTP_VIA;
	bool LogUserName;
	bool LogClientIP;
	CStringList Allow_URL_List;
	bool UseAllowURL;
	CStringList Allow_PATH_List;
	bool UseAllowPaths;
	bool ReadFromFile(LPCTSTR fn);
	bool UseDenyQuerystringSequences;
	bool UseDenyPOSTSequences;
	CStringList Deny_POST_Sequences;
	CStringList Deny_QUERYSTRING_Sequences;
	CStringList Deny_SQL_KeyWords;
	bool Deny_POST_SQLinjection;
	bool Deny_QUERYSTRING_SQLinjection;
	int LogRetention;
	bool ScanNonSecurePort;
	bool ScanSecurePort;
	bool IsInstalledAsGlobalFilter;
	bool ResponseLogOnly;
	bool LogAllowedRequests;
	CStringList Allow_VERSION_List;
	bool UseAllowVersions;
	bool UseMaxHeaders;
	CMapStringToString MaxHeaders;
	bool LimitVersion;
	bool LimitQueryString;
	bool LimitURL;
	bool LimitContentLength;
	long MaxVersion;
	long MaxQueryString;
	long MaxURL;
	CString MaxContentLength; //CString object!!!
	bool UseDenyURLSequences;
	CStringList Deny_URL_Sequences;
	bool UseResponseStatus;
	CString ResponseStatus;
	CString ResponseRedirectURL;
	bool ResponseRedirect;
	bool UseDenyHeaders;
	CStringList Deny_HEADER_List;
	bool UseDenyVerbs;
	bool UseAllowVerbs;
	CStringList Deny_VERB_List;
	CStringList Allow_VERB_List;
	CString ServerHeader;
	bool ChangeServerHeader;
	bool RemoveServerHeader;
	CStringList Allow_EXTENSION_List;
	CStringList Deny_EXTENSION_List;
	bool AllowLateScanning;
	bool UseDenyExtensions;
	bool UseAllowExtensions;
	CStringList Deny_FILENAME_CGIApplications;
	bool Deny_PATH_Dot;
	
	CString Deny_FILENAME_Characters;

	bool Deny_FULLPATH_Backspace;
	bool Deny_FULLPATH_CarriageReturn;
	bool Deny_FULLPATH_NewLine;
	bool Deny_FULLPATH_Escaping;
	bool Deny_FULLPATH_ParentPath;
	CString Deny_FULLPATH_Characters;

	bool Deny_URL_MultipleCGI;
	bool Deny_URL_Escaping;
	bool Deny_URL_AlternateStream;
	bool Deny_URL_Backslash;
	bool Deny_URL_TrailingDotInDir;
	bool Deny_URL_ParentPath;
	CString Deny_URL_Characters;

	CString LogDir;
	bool Logging;

	void LoadDefaults();
	CWebKnightSettings();
	virtual ~CWebKnightSettings();

private:
	bool EnableASP();
	bool EnableStaticHTML();
	bool EnableASPDotNet();
	inline void LoadISADefaults();
	inline void LoadIISDefaults();
	bool EnableSBS();
	bool EnableCommerceServer();
	bool EnableBizTalk();
	bool EnableCertificateServices();
	bool EnableSPTeamServices();
	bool EnableSPPortalServer();
	CString LogDirDefault;
	bool EnableIISADMPWD();
	bool EnableWebDAV();
	bool EnableFlash();
	bool EnableFrontpage();
	bool EnableColdfusion();
	bool EnableOWA();
	void ParseXML(CString key, CString val);
	void LoadInvalidValues();
	bool ReadFromFileINI(LPCTSTR fn);
	bool WriteToFileINI(LPCTSTR fn);
	bool WriteToFileXML(LPCTSTR fn);
	bool ReadFromFileURLScan(LPCTSTR fn);
};

#endif // !defined(AFX_WEBKNIGHTSETTINGS_H__E2FABE74_F5AD_44C6_A64E_FE3890A980EC__INCLUDED_)
